#define  MAIN
#include "opti.h"
/*
********************************************************************************
* MAIN   MAIN   MAIN   MAIN   MAIN   MAIN   MAIN   MAIN   MAIN   MAIN   MAIN  *
********************************************************************************
*/
int main( int argc, char *argv[])
{  
   int			i, loop, gebracht;
   char			monat[12];
  
  /* --------------------------
     Startwerte setzen
     -------------------------- */
   memset(BLOFIL, 0, sizeof(BLOFIL));
	STARTZEIT   = get_zeit(0);
	deutscher_monat(monat);
	sprintf (VERSION, "Auriga Systembau - Version vom %-2.2s.%-s%s um %-5.5s ",
			 &__DATE__[4], monat, &__DATE__[7], __TIME__) ;
	srand (time(NULL));
	neue_vorgaben();
	if (TP9 == 5069)
		ICH_BINS = TRUE;
	
	/* VARI  initialisieren */
	
	VARIATIONEN = vari_speichern();
	if (VARIATIONEN == BAD)
		return (BAD);
		
	if (ABBRUCH)
		return (BAD);
 
	/* Start-System erstellen oder einlesen */

	if (TIPPS)
	{                                        	/* Startsystem erstellen */
		if (TIPPS > VARIATIONEN )
		{
			TIPPS  = VARIATIONEN;            	/* maximal VARIATIONEN = Vollsystem */
			VOLLSYSTEM = TRUE;
		}
		if (VOLLSYSTEM)
		{
			printf("TIPPS=%i, VARIATIONEN=%i \n", TIPPS, VARIATIONEN); 
			zeige_system(SCHREIBEN);
			printf ("Vollsystem mit %i Tipps ausgegeben\n", TIPPS);
			return (OK);
		}
		
		if (TP8 > 100)
			baue_start_test(TIPPS); 	/* Testversion */
		else
			baue_start(TIPPS);    	   /* voroptimiert aus moeglichen Variationen */
	/*
	printf("Zeile=%i, VERSUCHE=%i \n", __LINE__, TIPPS); 
	zeige_daten( TIPP_TAB, 48, 'i', 3);      
	*/
	}
	else
      lies_system(1);   			    			/* aus Datei holen */
	bessere_tipps(SPEICHERN,1);
	bessere_tipps(SPEICHERN,2);
	   
	for (i=TIPPS; i < TIPPS+10; i++)
		TIPP_TAB[i].var_akt = BAD;

	/* Anfangs-Parameter fuer Optimierung festlegen */

	OPTIMAL_RANG2 *= TIPPS;
	if (OPTIMAL_RANG2 > (VARIATIONEN -TIPPS))
		OPTIMAL_RANG2 = VARIATIONEN -TIPPS;
	
	/* Auswertung Systemvorgabe */

	berechne_raenge_voll();
	berechne_ungleiche_voll();
	MEHR_TREFFER  = gib_treffer_wert();
	ZWI1_TREFFER  = MEHR_TREFFER;
	ZWI2_TREFFER  = MEHR_TREFFER;
	MAX_TREFFER   = MEHR_TREFFER;
	zeige_system(SCHREIBEN);
	zeige_auswertung(1);
	if (optimum_erreicht())
		return (OK);
		
	/* Test-Block 
	for (loop=0; loop<1; loop++)
	{
		i = minimax_tipp_redun(PLUS);
		printf ("i = %i \n", i); 
	} */
	
	/* Start der Optimierung */
	
	memcpy(SAV_RANG_TAB, RANG_TAB, sizeof(int)*5*VARIATIONEN);         /* Tabellen sichern */ 
	memcpy(SAV_TIPP_TAB, TIPP_TAB, sizeof(TIPP_TAB[0])*TIPPS); 
	memcpy(SAV_TIPP_REDU, TIPP_REDU, sizeof(TIPP_REDU)); 

	LOOP_ZEIT     = clock();
	LOOP_VERSUCHE = 0;
	
	/* Optimierungs-Loop */
	
	zeitraum_starten();
	for (loop=1; loop<WIE_OFT; loop++)
	{
	
		if (TREFFER[0] >120000)
		{
			printf("Zeile=%i, VERSUCHE=%i \n", __LINE__, TIPPS); 
			zeige_daten( TIPP_TAB, TIPPS*4, 'i', 4);      
			return (OK);
		}
				
		LOOP_VERSUCHE ++;
		SCHALTER 		= (VERSUCHE >>0) &7;
      
		METHODE_REIN	= METHODEN[VERSUCHE %strlen(METHODEN)];
		METHODE_RAUS	= METHODE_REIN;
		
		/* zuerst einmal ganze Diff-Tabelle initialisieren */
		
		for (i=0; i<TIPPS; i++)
		{
			TIPP_TAB[i].ungleich = 0;
			TIPP_TAB[i].zwi      = 0;
			TIPP_TAB[i].var_alt  = BAD;
		}
		/* dann Optimierungs-Versuch */
		
		if (ANLAUF_ZEIT)
			FEST_GEFRESSEN = zeitraum_abgelaufen(ANLAUF_ZEIT);
		
		optimiere(); 
		if (PROGRAMM_FEHLER)
		{
			printf("es wird mit neuem Anlauf aufgesetzt !\n");
			_sleep(5);
			continue;
		}
		
		gebracht = was_gebracht();
		
		if (gebracht >0)
		{
			zeitraum_starten();
			if (optimum_erreicht())
				break;
		}
		if (gebracht <0)
			wechsele_zurueck('R');
		else
		{
			memcpy(SAV_RANG_TAB, RANG_TAB, sizeof(int)*5*VARIATIONEN);   /* veraenderte Tabellen sichern */		
			memcpy(SAV_TIPP_TAB, TIPP_TAB, sizeof(TIPP_TAB[0])*TIPPS); 
			memcpy(SAV_TIPP_REDU, TIPP_REDU, sizeof(TIPP_REDU)); 
		}
		neue_vorgaben();
	}
	/* zeige_daten( RANG_TAB, 5*VARIATIONEN , 'i', 5); */
	return (2);
}
/*
*****************************************************************************
*  aktualisiere_system  -  aktualisiert das System bei Block-Wechsel
*****************************************************************************
*/
void   aktualisiere_system(char modus)
{
	int	tv, tn, i1, i2;

	/* wenn Systemzeilen vorhanden */
	if (modus == SPEICHERN_SYSTEM)
	{
		SYSTEM_TIPPS  = TIPP;
	}
	
	/* wenn Tipp-Block vorhanden */
	if (BLOCK_SPIELE)
	{
		/* zuerst System lt. Blocklaenge multiplizieren */
		tv = 0;
		tn = tv + (SYSTEM_TIPPS *SPIELE);
		for (i1=SYSTEM_TIPPS; i1<(SYSTEM_TIPPS*BLOCK_TIPPS); i1++)
		{
			memcpy (&CTAB[tn], &CTAB[tv], SYSTEM_SPIELE);
			tv += SPIELE;
			tn += SPIELE;
		}
	
		/* dann jeden Block-Tipp lt. Systemlaenge duplizieren */
		/* rueckwaerts - um nichts zu ueberschreiben */
		tv = SYSTEM_SPIELE + ((BLOCK_TIPPS -1) *SPIELE);
		tn = SYSTEM_SPIELE + ((BLOCK_TIPPS *SYSTEM_TIPPS -1) *SPIELE);
		for (i1=0; i1<BLOCK_TIPPS; i1++)
		{
			for (i2=0; i2<SYSTEM_TIPPS; i2++)
			{
				memcpy (&CTAB[tn], &CTAB[tv], BLOCK_SPIELE);
				tn -= SPIELE;
			}
			tv -= SPIELE;
		}
		/* neue System-Dimensionen setzen */
		SYSTEM_TIPPS  *= BLOCK_TIPPS;
	}
	SYSTEM_SPIELE = SPIEL;
	BLOCK_SPIELE = 0;
	BLOCK_TIPPS  = 0;
}
/*
**********************************************************************
*   baue_start - Start-System voroptimiert aufbauen
**********************************************************************
*/
void   baue_start (int tipps)
{
   int	iv=BAD, it, tipp=0;
   
	memset (RANG_TAB,   0, VARIATIONEN*5*sizeof(int));
	memset (VAR_TIPPS, 0, VARIATIONEN);
	
	for (it=0; it < TIPPS+10; it++)
		TIPP_TAB[it].var_akt = BAD;
			
	tipp = baue_start_test (tipps);
	while (tipp < tipps)
	{
		minimax_vari_wert(); 
		iv = MINIMAL; 

		VAR_TIPPS[iv] = 1;
		TIPP_TAB[tipp].var_akt = iv;
		berechne_raenge(iv,PLUS);
		tipp ++;
	}
}
/*
**********************************************************************
*   baue_start_test - Start-System mit Testversion aufbauen
**********************************************************************
*/
int   baue_start_test (int tipps)
{
   int	it=0, itx, iv=0, ivx, tipp=0;
   char	ungleiche;
   
	iv = zufall(VARIATIONEN);
	VAR_TIPPS[iv] = 1;
	TIPP_TAB[0].var_akt = iv;
	tipp = 1;
	while (tipp < tipps)
	{
		for(iv=0; iv < VARIATIONEN; iv++)
		{
			if (VAR_TIPPS[iv])
				continue;
			ivx = iv*SPIELE;
			for (it=0; it < tipp; it++)
			{
				itx = TIPP_TAB[it].var_akt *SPIELE;
				ungleiche = zaehle_ungleiche(&VARI[ivx], &VARI[itx]);
				if (ungleiche != SPIELE-1)
				{
					it = BAD;
					break;
				}
			}
			if (it != BAD)
			{
				// gewaehlten Tipp einspeichern
				VAR_TIPPS[iv] = 1;
				TIPP_TAB[tipp].var_akt = iv;
				tipp++;
				berechne_raenge(iv,PLUS);
			}
		}
		break;
	}
	return (tipp);
}
/*
*******************************************************************************
*  berechne_raenge - Rangtreffer eines Tipps gegen alle Variationen verrechnen
*******************************************************************************
*/
void   berechne_raenge(int tvar, int wert)
{
	int    	ir, iv, it, var, ungleiche;

  /* -----------------------------------------------------------
	  Durchlauf durch alle Variationen mit Treffer-Anpassung
	  * wert =  1 - Trefferanzahl erhoehen, 
	  * wert = -1 - Trefferanzahl reduzieren
	  ----------------------------------------------------------- */

	 
  /* Tipp lt. tvar gegen alle Variationen */
  
	VAR_TIPPS[tvar] += wert;
	it = tvar *SPIELE;
	for (var=0; var < VARIATIONEN; var++)
	{
		/* gegen eine Variation */
		iv = var*SPIELE;
		ungleiche = zaehle_ungleiche(&VARI[iv], &VARI[it]);
		if (ungleiche < 4)
		{
			ir = var*5+ungleiche+1;
			RANG_TAB[ir] += wert;
			
			/* MINUS - auf Unterlauf pruefen */
			if (RANG_TAB[ir] <0)
			{
				printf("\nZeile %i - RANG_TAB negativ bei Tipp %i, var %i  VERSUCHE %i, Methode %c\n",
				       __LINE__, tvar, var, VERSUCHE, METHODE_REIN);
				PROGRAMM_FEHLER = __LINE__-4;
				break;
			}
		}
	}
}
/*
*****************************************************************************
*  berechne_raenge_voll  - komplette Rangtreffer-Ermittlung und Summierung 
*****************************************************************************
*/
void   berechne_raenge_voll(void)
{
  int    tipp, iv;

  /* erst durchloeschen */
  /* zeige_daten( VARI, 30*3, 'b', SPIELE); */
  memset (RANG_TAB,  0, VARIATIONEN*5*sizeof(int));
  memset (VAR_TIPPS, 0, VARIATIONEN);

	/* berechnen */
	
  for (tipp=0; tipp < TIPPS; tipp++)
  {
		iv = TIPP_TAB[tipp].var_akt;
		berechne_raenge(iv, PLUS);
		/*
		zeige_daten( TIPP_TAB, 18, 'i', 3);		
		zeige_daten( RANG_TAB, 30*5, 'i', 5);	
		*/
  }
  
  /*  Treffer-Summierung aus RANG_TAB */
  gib_treffer_summen();
  MEHR_TREFFER = gib_treffer_wert();
}
/*
*****************************************************************************
*  berechne_ungleiche - rechnet Redundanzen fuer einen Tipp rein oder raus
*****************************************************************************
*/
void  berechne_ungleiche(int it, int wert)
{
	int	it2, iv, iv2; 
	int	ungleiche, links;
	
	/* zuerst die 6 Bits Zufallswert herausschieben */
	for (it=0; it<TIPPS; it++)
		TIPP_TAB[it].ungleich  >>= 6;

	/* dann vorgegebenen Tipp gegen alle anderen rechnen */
	
	iv  = TIPP_TAB[it].var_akt *SPIELE;
	for (it2=0; it2<TIPPS; it2++)
	{
		if (it == it2)
			continue;
			
		iv2 = TIPP_TAB[it2].var_akt *SPIELE;

		ungleiche = zaehle_ungleiche(&VARI[iv], &VARI[iv2]);
		if (ungleiche <8)
		{
			 links = (7-ungleiche)*3;
			 TIPP_TAB[it].ungleich  += (wert << links);
			 TIPP_TAB[it2].ungleich += (wert << links);
			 TIPP_REDU[ungleiche] += wert;
		}
		if (wert == MINUS)
				/* MINUS - auf Unterlauf pruefen */
			if ((TIPP_TAB[it].ungleich <0) || (TIPP_TAB[it2].ungleich <0) || (TIPP_REDU[ungleiche] <0))
			{
				printf("\n*************************************************************"
						 "\nTIPP_TAB-ungleiche negativ bei Tipp %i und %i  VERSUCHE %i"
				       "\n*************************************************************", it, it2, VERSUCHE);
				PROGRAMM_FEHLER = __LINE__;
				und_tschuess (__LINE__, 0);
			}
	}
	/* und wieder um 6 Bits Zufallswert erweitern */
	for (it=0; it<TIPPS; it++)
		TIPP_TAB[it].ungleich = (TIPP_TAB[it].ungleich << 6) + zufall(1 << 6);
		
}
/*
*****************************************************************************
*  berechne_ungleiche_voll - berechnet alle Tipp-Redundanzen
*****************************************************************************
*/
void  berechne_ungleiche_voll(void)
{
	int	it, it2, iv, iv2; 
	int	ungleiche, links;
	

	/* erst .ungleich loeschen */
	for (it=0; it<TIPPS; it++)
	{
		TIPP_TAB[it].ungleich = 2;
	}
	for (it=0; it<8; it++)
	{
		TIPP_REDU[it] = 0;
	}
	
	/* dann jeder gegen jeden rechnen */
	for (it=0; it<(TIPPS-1); it++)
	{
		iv  = TIPP_TAB[it].var_akt *SPIELE;
		for (it2=it+1; it2<TIPPS; it2++)
		{
			iv2 = TIPP_TAB[it2].var_akt *SPIELE;

			ungleiche = zaehle_ungleiche(&VARI[iv], &VARI[iv2]);
			if (ungleiche <8)
			{
				 links = (7-ungleiche)*3;
				 TIPP_TAB[it].ungleich  += (1 << links);
				 TIPP_TAB[it2].ungleich += (1 << links);
				 TIPP_REDU[ungleiche] ++;
			}
		}
	}
	/* um 6 Bits Zufallswert erweitern */
	for (it=0; it<TIPPS; it++)
		TIPP_TAB[it].ungleich = (TIPP_TAB[it].ungleich << 6) + zufall(1 << 6);
}
/*
*****************************************************************************
*  bessere_tipps  -  bessere TIPP_TAB, speichern oder zurueckholen
*****************************************************************************
*/
void     bessere_tipps(char aktion, char woher)
{
   int   i;
     
   for (i=0; i<TIPPS; i++)
	{
		if (aktion == SPEICHERN)
		{
			if (woher == 1)
				TIPPS_EINS[i] = TIPP_TAB[i].var_akt ;
			else
				TIPPS_ZWEI[i] = TIPP_TAB[i].var_akt ;
		}
		else
		{
			if (woher == 1)
				TIPP_TAB[i].var_akt = TIPPS_EINS[i];			
			else
				TIPP_TAB[i].var_akt = TIPPS_ZWEI[i];			
		}
	}
}
/*
*****************************************************************************
*  den_nicht_rein  
*****************************************************************************
*/
int     den_nicht_rein(int aktion, int var)
{
   int   antwort = FALSE;
     
	if (aktion == SPEICHERN)
	{
		NICHT_REIN[2] = NICHT_REIN[1];
		NICHT_REIN[1] = NICHT_REIN[0];
		NICHT_REIN[0] = var;
	}
	else
	{
		if ((NICHT_REIN[0] == var) || (NICHT_REIN[1] == var) || (NICHT_REIN[2] == var))
			antwort = TRUE;
			
		if (VAR_TIPPS[var])
			antwort = TRUE;
	}
	return (antwort);
}
/*
*****************************************************************************
*  deutscher_monat - deutscher Monat aus __DATE__
*****************************************************************************
*/
void  deutscher_monat(char *monat)
{
	char		i;
	struct	struct_monate{
		char	englisch[4];
		char	zahl[4];
		char	deutsch[12];
	}monate[] = { 
		"Jan", "1.", "Januar",		"Feb", "2.", "Februar",		"Mar", "3.", "Maerz",
		"Apr", "4.", "April",		"May", "5.", "Mai",			"Jun", "6.", "Juni",
		"Jul", "7.", "Juli",			"Aug", "8.", "August",		"Sep", "9.", "September",
		"Oct", "10.", "Oktober",	"Nov", "11.", "November",	"Dec", "12.", "Dezember",
		"---", "13.", "Fehler",
	};
					
	strcpy (monat, "Fehler");
	for (i=0; i<13; i++)
		if (strncmp(monate[i].englisch, __DATE__, 3) == OK)
		{
			strcpy(monat, monate[i].zahl);
			break;
		}

}
/*
*****************************************************************************
*  filter_pruefung - Tippreihe gegen Filter-Vorgaben pruefen
*****************************************************************************
*/
char filter_pruefung(char *reihe)
{
	char anzahl[3];
	char label[8];
	char i;
	char status = OK;
	int  ib, spiel_bits;

	for (ib=0; BLOFIL[ib].spiel_bits>0; ib++)
	{	
		status = OK;
		spiel_bits  = BLOFIL[ib].spiel_bits;
		
		/* erst Tippbild ermitteln */
		for (i=0; i<3; i++)
			anzahl[i] = 0;
			
		for (i=0; i<SPIELE; i++)
		{
			if (spiel_bits & 1)
				anzahl[reihe[i]] ++;
			spiel_bits >>= 1;
		}
		if (spiel_bits)
		{
			printf("\n**********************************************************"
					 "\n  Filter in Zeile %i fuer mehr Spiele als vorgegeben "
			       "\n**********************************************************", BLOFIL[ib].vorgabe_zeile);
			und_tschuess (__LINE__, 0);
		}

		/* dann pruefen ob in den Grenzen */
		for (i = 0; i < 3; i++)
		{
			if (anzahl[i] < BLOFIL[ib].grenze[i*2] || anzahl[i] > BLOFIL[ib].grenze[i*2+1])
			{
				status = BAD;
				break;
			}
		}
		if (status == OK)
		{
			/* wenn ok weiterpruefen oder zum angegebenen Label springen */
			if (BLOFIL[ib].ok[0])
			{
				strcpy(label, BLOFIL[ib].ok);
				if (strcmp(label, "OK") == OK)        /* Filterpruefung OK und fertig */
					break;
					
				while ((BLOFIL[ib+1].spiel_bits)  &&  (strcmp(label, BLOFIL[ib+1].name) != OK))	
					ib++;
					
				if (BLOFIL[ib+1].spiel_bits == 0)
				{
					status = BAD;						/* Name nicht gefunden */
					break;
				}
			}
		}
		else
		{
			/* wenn falsch und Label angegeben, dorthin - sonst Filterfehler */
			if (BLOFIL[ib].falsch[0] == FALSE)
				break;
				
			status = OK;
			strcpy(label, BLOFIL[ib].falsch);
			while ((BLOFIL[ib+1].spiel_bits)  &&  (strcmp(label, BLOFIL[ib+1].name) != OK))	
				ib++;
				
			if (BLOFIL[ib+1].spiel_bits == 0)
			{
				status = BAD;						/* Name nicht gefunden */
				break;
			}
		}            
	}
	return (status);
}
/*
*****************************************************************************
*  get_zeit - globale Zeitstruktur fuellen
*****************************************************************************
*/
int  get_zeit(time_t *sekunden)
{
  time_t   t1;
  struct   tm *t;

  t1 = time( sekunden );
  t  = localtime(&t1);

  return (((t->tm_yday*24 + t->tm_hour)*60 + t->tm_min)*60 + t->tm_sec); 
}
/*
*****************************************************************************
*  gib_redu_wert   Werte aus TIPP_REDU
*****************************************************************************
*/
int  gib_redu_wert(void)
{
	int    i, redu_wert=0;
	
	for(i=0; i<8; i++)
	{
		redu_wert <<= 2;
		redu_wert += TIPP_REDU[i];
	}
	return (redu_wert);
}
/*
*****************************************************************************
*  gib_treffer_summen  -  summiert Treffer ueber die die RANG_TAB
*****************************************************************************
*/
void   gib_treffer_summen(void)
{
  int    i, ir, var;

  for (i=0; i<4; i++)
  {
	 TREFFER[i]=0;
  }
  for (var=0; var < VARIATIONEN; var ++)
  {
		ir = var*5;
		
		/* erst besten Treffer dieser Variation ermitteln */
		
		RANG_TAB[ir] = 0;
		for (i=1;i<=4; i++)
			if (RANG_TAB[ir+i])
			{
				RANG_TAB[ir] = i;
				break;
			}
			
		/* dann Summen berechnen */
		
		if (RANG_TAB[ir] >0)
		{
			TREFFER[RANG_TAB[ir]-1] ++; 
		}
		/*
 printf("var=%6i RANG_TAB   %i   %i %i %i %i  \n", 
	var, RANG_TAB[var*5+0], RANG_TAB[var*5+1], RANG_TAB[var*5+2], RANG_TAB[var*5+3], RANG_TAB[var*5+4]);
 printf("%i %i %i %i  TREFFER \n", TREFFER[0], TREFFER[1], TREFFER[2], TREFFER[3]); 
		*/
  }
}
/*
*****************************************************************************
*  gib_treffer_wert  - Werte aus RANG_TAB
*****************************************************************************
*/
int  gib_treffer_wert(void)
{
	int    i, treffer, treffer_wert=0;
	
	for(i=0; i<4; i++)
	{
		treffer = TREFFER[i] +3-i;
		treffer  <<= RANG_BITS[i];
		treffer_wert += treffer;
	}
	return (treffer_wert);
}
/*
*****************************************************************************
*  gleicher_tipp - Zwei Tipps vergleichen
*****************************************************************************
*/
char  gleicher_tipp(char* var, char* tipp)
{
  char     spiel, gleich=TRUE;
	
	for (spiel=0; spiel < SPIELE; spiel++)
	{
		if (var[spiel] != tipp[spiel])
		{
			gleich = FALSE;
			break;
		}
	}
  return (gleich);
}
/*
***********************************************************************************
*   lies_system - Start-System aus Datei holen
***********************************************************************************
*/
char   lies_system (char user_auswahl)
{
	FILE*    system_file = NULL ;
	char     system_name[]="vorsys.txt";
	char     zeile[20003];
	char     modus=SPEICHERN_SYSTEM;
	int	   i, spiel, tipp, var, varstart, laenge;
	int		wege[MAX_SPIELE+2];
	
	SPIEL = 0;
	
	/* ------------------------------------------------
			System einlesen und speichern
		 ------------------------------------------------ */
	SYSTEM_SPIELE  = 0;
	SYSTEM_TIPPS   = 0;
	SPIEL          = 0;
	TIPP           = 0;
	system_file = fopen(system_name,"r");
	if (system_file == NULL)
	{
		printf ("\nSystemdatei >%s< kann nicht eroeffnet werden\n", system_name);
		und_tschuess (__LINE__, 0);
	}

	while (fgets(zeile, 20001, system_file))
	{
		laenge = strlen(zeile);
		
		/* Linefeed raus */
		string_to_upper(zeile, zeile);
		if (zeile[laenge-1] < 040)
			zeile[laenge-1] = 0;
		
		if (strncmp(zeile,"DATEI_ENDE",11) == OK)
			break;		
		
		if ((strncmp(zeile,"SYSTEM",6) == OK))
		{
			/* evtl. schon vorhandenes System aktualisieren */
			aktualisiere_system(modus);
			modus = SPEICHERN_SYSTEM;
			SPIEL = 0;
			TIPP  = SYSTEM_TIPPS;
			continue;
		}
		
		if ((strncmp(zeile,"MULTI",5) == OK))
		{
			/* evtl. schon vorhandenes System aktualisieren */
			aktualisiere_system(modus);
			modus = SPEICHERN_BLOCK;
			SPIEL = SYSTEM_SPIELE;
			TIPP  = 0;
			continue;
		}
		/* zum Speichern relevante Zeile ? */
		for (i=0; i<laenge; i++)
		{
			if (zeile[i] == 'X' || zeile[i] == '1' || zeile[i] == '0' || zeile[i] == '2')
			{
				/* ja - speichern */
				speichere_system_zeile(modus, zeile);
				break;
			}
		}
	}
	/* fertiges System aktualisieren */
	aktualisiere_system(modus);
	
	TIPPS = SYSTEM_TIPPS;
	fclose(system_file);
	
	/* ------------------------------------------------
			VARI-Nummern ermitteln und einsetzen
		 ------------------------------------------------ */
	wege[SPIELE-1] = 1;
	for (spiel=SPIELE-2; spiel>=0; spiel--)
		wege[spiel] = wege[spiel+1] *WEG[spiel+1];

	for (tipp=0; tipp<TIPPS; tipp++)
	{
		if (BLOFIL[0].spiel_bits >0)
		{
			/* Filterfehler kennzeichnen zum spaeteren Ausschluss */
			if (filter_pruefung(&CTAB[tipp *SPIELE]) == BAD)
			{
				TIPP_TAB[tipp].var_akt = 100000000;
				continue;
			}
		}
		TIPP_TAB[tipp].var_akt = 0;
		TIPP_TAB[tipp].var_alt = tipp;        /* fuer richtigen Zugriff auf CTAB nach dem qsort */
		for (spiel=0; spiel<SPIELE; spiel++)
			TIPP_TAB[tipp].var_akt += (CTAB[tipp *SPIELE +spiel] *wege[spiel]) ;
	}
	/* Bei Filtern sind die VARI-Nummern falsch 
	 * und muessen neu, direkt aus VARI ermittelt werden 
	 * Filterfehler werden dabei ausgeschlossen */
		
	if (BLOFIL[0].spiel_bits >0)
	{
		/* dazu nach VARI-Nummern sortieren, sequentiell gegen die VARI
		 * laufen und die richtige Nr. besorgen */
		
		SORTIERUNG = 0;
		qsort (TIPP_TAB, TIPPS, sizeof(TIPP_TAB[0]), sor);
//		zeige_tipptab(__LINE__, 0);
		varstart = 0;
		for (tipp=0; tipp<TIPPS; tipp++)
		{
			if (TIPP_TAB[tipp].var_akt >= 100000000)
			{
				/* nur noch Filterfehler - TIPPS reduzieren und raus */
				TIPP_TAB[tipp].var_akt = BAD;
				TIPPS = tipp;
				break;
			}
			/* sonst richtige Vari-Nr. ermitteln */
			TIPP_TAB[tipp].var_akt = 0;
			for (var=varstart; var<VARIATIONEN; var++)
			{
				if (gleicher_tipp(&VARI[var*SPIELE], &CTAB[TIPP_TAB[tipp].var_alt*SPIELE]))
				{
					TIPP_TAB[tipp].var_akt = var;
					varstart = var+1;
					break;
				}
			}
		}
	}
	
	/* var_alt wieder freigeben */
	
   for (tipp=0; tipp<TIPPS; tipp++)
      TIPP_TAB[tipp].var_alt = BAD;

	/* und Tipps zum Wiederaufsetzen merken */
	
	bessere_tipps(SPEICHERN, 1);
	bessere_tipps(SPEICHERN, 2);
//	zeige_tipptab(__LINE__, 0);
	return (OK);
}
/*
***********************************************************************************
*   lies_vorgaben
***********************************************************************************
*/
char   lies_vorgaben (char erstmalig)
{
	FILE*				vorgaben_file = NULL;
	char				VORGABEN_NAME[]="vorgaben.txt";
	char				zeile[200];
	int				eingabe, vorgabe_zeile=0, laenge;
	int				i, i2, blz_x=0;

	/* ------------------------------------------------
			Vorgaben einlesen und speichern
		------------------------------------------------ */

	vorgaben_file = fopen(VORGABEN_NAME,"r");
	if (vorgaben_file == NULL)
	{
		printf ("\nVorgaben-Datei >%s< kann nicht eroeffnet werden\n", VORGABEN_NAME);
		und_tschuess (__LINE__, 0);
	}
	
	while (fgets(zeile, 199, vorgaben_file))
	{
		vorgabe_zeile ++;
		if (zeile[0] == '-')				/* auskommentiert ? */
			continue;
	
		laenge = strlen(zeile)-1;
		if (zeile[laenge] < 040)  /* Zeilenende absichern */
			zeile[laenge] = 0;
	
		for (i=0; i < laenge; i++)  /* TABs zu Blank */
			if (zeile[i] == TAB)
				zeile[i] = ' ';
		
		string_teilen(zeile,' ');
	
		/* -------------------------------------------------
		 -	folgende Parameter nur einmal uebernehmen 
		 ----------------------------------------------------*/

		if (erstmalig)
		{
			/* 2er und 3er-Wege */
	
			if (strcmp(TEIL[0].STRING,"WEGE") == OK)
			{
				string_teilen(zeile, '|');
				for (i=0; TEIL[1].STRING[i]>'0'; i++)
				{
					WEG[i]			=  TEIL[1].STRING[i]-'0';
					VARIATIONEN		*= (TEIL[1].STRING[i]-'0');
					OPTIMAL_RANG2	+= (TEIL[1].STRING[i]-'0'-1);
				}
				SPIELE            = i;
			}
	
			/* Filter */
	
			if ((blz_x == 0)  &&  (strcmp(TEIL[0].STRING,"FILTER") == OK)  &&  (strcmp(TEIL[1].STRING,"|N") == OK))
			     FILTER = FALSE;
	
			if (FILTER)
			{
				if ((strcmp(TEIL[0].STRING,"FILTER") == OK)  &&  (blz_x < MAX_FILTER))
				{
					string_teilen(zeile, '|');
					for (i=0; i<8; i++)
					{
						for (i2=strlen(TEIL[i].STRING); i2>=0; i2--)
						{
							if (TEIL[i].STRING[i2] > ' ')
								break;
							TEIL[i].STRING[i2] = 0;
						}
					}
					if (setze_filter(blz_x, vorgabe_zeile))
						blz_x ++;
				}
			}
			/* Anfangs-System automatisch anlegen ? */
	
			if (strcmp(TEIL[0].STRING,"SYSTEM_BAUEN") == OK)
			{
				eingabe = TEIL[1].STRING[0];
				
				switch (eingabe)
				{
					case 'V' :		/* Vollsystem ausgeben */
					VOLLSYSTEM = TRUE;
					TIPPS = 99999999;
					break;
			
					case 'S' :		/* System aus Datei - senkrecht orientiert */
					SENKRECHT_EIN = TRUE;
					TIPPS = 0;
					if (strlen(TEIL[1].STRING) >1)
						SOLL_TIPPS = atoi(&TEIL[1].STRING[1]);
					break;
			
					case 'W' :		/* System aus Datei - waagerecht orientiert */
					SENKRECHT_EIN = FALSE;
					TIPPS = 0;
					if (strlen(TEIL[1].STRING) >1)
						SOLL_TIPPS = atoi(&TEIL[1].STRING[1]);
					break;
			
					default :
					TIPPS = atoi(TEIL[1].STRING);
					if (TIPPS > MAX_TIPPS)
						TIPPS = MAX_TIPPS;
				}
			}
			/* Shift-Bits je Rang bei abweichender Treffer-Bewertung */
	
			if (strcmp(TEIL[0].STRING,"ZIEL-RANG") == OK)
			{
				eingabe = TEIL[1].STRING[0] -'0';
				if (eingabe != 2)
				{
					ZIEL_RANG = eingabe;
					if ((ZIEL_RANG < 2)  ||  (ZIEL_RANG > 4))
						und_tschuess (__LINE__, 4);  /* nur 2 bis 4 erlaubt */
						
					if (ZIEL_RANG == 3)
						RANG_BITS[2] = 8;
						
					if (ZIEL_RANG == 4)
						RANG_BITS[3] = 4;
				}
			}
		}	
		/* -------------------------------------------------
		 -	ab hier bei jeder Aenderung von vorgaben.txt
		 ----------------------------------------------------*/
		
		/* 9 Test-Parameter */

		if (strcmp(TEIL[0].STRING,"TEST-PARAMETER") == OK)
		{
			TP1 = atoi(TEIL[1].STRING);
			TP2 = atoi(TEIL[2].STRING);
			TP3 = atoi(TEIL[3].STRING);
			TP4 = atoi(TEIL[4].STRING);
			TP5 = atoi(TEIL[5].STRING);
			TP6 = atoi(TEIL[6].STRING);
			TP7 = atoi(TEIL[7].STRING);
			TP8 = atoi(TEIL[8].STRING);
			TP9 = atoi(TEIL[9].STRING);
		}
		
		/* Rang-Bits */

		if ((strcmp(TEIL[0].STRING,"RANG-BITS") == OK))
		{
			for (i=0; i<4; i++)
				RANG_BITS[i] = atoi(TEIL[i+1].STRING);
		}
	
		/* Shift-Faktor RAUS */

		if (strcmp(TEIL[0].STRING,"RAUS") == OK)
		     RAUS = atoi(TEIL[1].STRING);

		/* Shift-Faktor REIN */

		if (strcmp(TEIL[0].STRING,"REIN") == OK)
		     REIN = atoi(TEIL[1].STRING);

		/* Anzahl Durchlaeufe */
		
		if (strcmp(TEIL[0].STRING,"WIE_OFT") == OK)
		{
		  if (strcmp(TEIL[1].STRING,"U") == OK)
		     WIE_OFT = 1999999999 ;  
		  else
		     WIE_OFT = atoi(TEIL[1].STRING);
		}
		
		/* Methoden-Kreisel */

		if ((strcmp(TEIL[0].STRING,"METHODEN") == OK))
		{
			for (i=0; i<MAX_METHODEN; i++)
				METHODEN[i] = TEIL[1].STRING[i];
			METHODEN[MAX_METHODEN] = 0;
			METHODE_RAUS = METHODEN[0];
			METHODE_REIN = METHODEN[0];
		}
		
		/* Anzahl Sekunden fuer neuen Anlauf */
		
		if (strcmp(TEIL[0].STRING,"ANLAUF-ZEIT") == OK)
		{
		     ANLAUF_ZEIT = atoi(TEIL[1].STRING);
		}

		/* Anzahl auszutauschender Tippzeichen bei neuem Anlauf */
		
		if (strcmp(TEIL[0].STRING,"ANLAUF-WEITE") == OK)
		{
		     ANLAUF_WEITE = atoi(TEIL[1].STRING);
		}

		/* Sammelfeld waehrend neuer Entwicklung */

		if (strcmp(TEIL[0].STRING,"ZUFALL") == OK)
		     ZUFALL = atoi(TEIL[1].STRING);

		/* Prefix vor Systemzeile ? */

		if (strcmp(TEIL[0].STRING,"VORSPANN") == OK)
		{
			VORSPANN = TEIL[1].STRING[0];
			if (VORSPANN == 'N')
		     VORSPANN = 0;		     
			if (VORSPANN == 'L')
		     VORSPANN = ' ';		     
			if (VORSPANN == 'T')
		     VORSPANN = TAB;		     
		}
		
		/* System mit Trennzeichen unterteilen ? */

		if (strcmp(TEIL[0].STRING,"TRENN-ZEICHEN") == OK)
		{
			SYS_TRENNER = TEIL[1].STRING[0];
			if (SYS_TRENNER == 'N')
		     SYS_TRENNER = 0;		     
			if (SYS_TRENNER == 'L')
		     SYS_TRENNER = ' ';		     
			if (SYS_TRENNER == 'T')
		     SYS_TRENNER = TAB;		     
		}
		
		/* Anzahl Sekunden fuer neuen Anlauf */
		
		if (strcmp(TEIL[0].STRING,"TRENN-ABSTAND") == OK)
		{
		     SYS_TEILUNG = atoi(TEIL[1].STRING);
		}
		
		/* Zuordnung der Systemzeilen zum Spielplan */

		if (strcmp(TEIL[0].STRING,"AUS_SYSTEMSPIEL") == OK)
		{
			eingabe = 0;
			for (i=0; i<SPIELE; i++)
			{
				if (strlen(TEIL[i+1].STRING)<1)
					break;
				SPIEL_ZUORDNUNG[i] = atoi(TEIL[i+1].STRING)-1;
				eingabe += (SPIEL_ZUORDNUNG[i] +1);
			}
			// printf("%i Spiele Summe = %i, Zuordnung = %i ", SPIELE, eingabe, SPIEL_ZUORDNUNG[i-1+MAX_SPIELE]);
			if (eingabe != SPIEL_ZUORDNUNG[SPIELE-1+MAX_SPIELE])
				und_tschuess (__LINE__, 5); 		 // Spielplan-Zuordnung passt nicht
		}
		
		/* AUSGABE_ZEICHEN fuer 1, 0 und 2 lt. Spielplan */

		if (strcmp(TEIL[0].STRING,"102_WIRD_ZU") == OK)
		{
			for (i=1,i2=0; i<=SPIELE; i++,i2+=4)
			{
				if (strlen(TEIL[i].STRING)<1)
					break;
				AUSGABE_ZEICHEN[i2] 	 = TEIL[i].STRING[0];
				AUSGABE_ZEICHEN[i2+1] = TEIL[i].STRING[1];
				AUSGABE_ZEICHEN[i2+2] = TEIL[i].STRING[2];
			}
		}
		
		if (strcmp(TEIL[0].STRING,"SYSTEM_ZEIGEN") == OK)
		{
			if (strcmp(TEIL[1].STRING,"J") == OK)
				SYSTEM_ZEIGEN = TRUE;		     
			else
				SYSTEM_ZEIGEN = FALSE;		     
		}

		if (strcmp(TEIL[0].STRING,"ORIENTIERUNG") == OK)
		{
		  if (strcmp(TEIL[1].STRING,"S") == OK)
		     SENKRECHT_AUS = TRUE;		     
		  else
		     SENKRECHT_AUS = FALSE;		     
		}		
	}
	fclose(vorgaben_file);
	return (OK); 
}
/*
*****************************************************************************
*  min_tipp_ungleich - minimale Abweichung der Tipps gegen eine Variation
*****************************************************************************
*/
int  min_tipp_ungleich(int iv, int tipps)
{
	int	it, iv1, iv2, it_min=0; 
	int	ungleiche, min_ungleiche=SPIELE <<10;
	
	
	for (it=0; it<tipps; it++)
	{
			iv1 = iv*SPIELE;
			iv2 = TIPP_TAB[it].var_akt*SPIELE;
			ungleiche = (zaehle_ungleiche(&VARI[iv1], &VARI[iv2]) <<10) + zufall(1000);

			if (ungleiche < min_ungleiche)
			{
				min_ungleiche = ungleiche;
				it_min = it;
			}
	}
	return (it_min);
}
/*
*****************************************************************************
*  minimax_tipp_redun - sucht Tipp mit groesster oder kleinster Redundanz
*****************************************************************************
*/
int  minimax_tipp_redun(int plusminus)
{
	int	shift=RAUS;
	

	if (plusminus == MINUS)
	{
		shift    = REIN;
		SORTIERUNG = 2;
	}
	else
		SORTIERUNG = 102;
		
	/* erst alle ungleichen berechnen */
	berechne_ungleiche_voll();
	
	/* dann den gesuchten Trefferwert nach vorn sortieren */
		
	qsort (TIPP_TAB, TIPPS, sizeof(TIPP_TAB[0]), sor);	
	return (0);
}
/*
**********************************************************************************
*  minimax_vari_rang - sucht Variation mit bestem und schlechtestem Rang
**********************************************************************************
*/
void  minimax_vari_rang(void)
{
	int	i, ir=0, rang, var;
	int	minrang =999999999, maxrang=0, minvar=-1, maxvar=-1,shift=10;
	
	/* Variation mit bestem und schlechtestem Rang suchen */
	
	for (var=0; var<VARIATIONEN; var++, ir+=5)
	{			
		if (den_nicht_rein(PRUEFEN, var))
			continue;
				
		rang = 5;
		for(i=1; i<5; i++)
		{
			if (RANG_TAB[ir+i])
			{
				rang = i;
				break;
			}
		}
		rang = (rang <<10) + zufall(1 << shift);
		
		if (rang < minrang)		/* neuer bester ? */
		{
			minrang = rang;
			minvar  = var;
		}

		if (rang > maxrang)		/* neuer schlechtester ? */
		{
			maxrang = rang;
			maxvar  = var;
		}
	}
	MINIMAL = minvar;
	MAXIMAL = maxvar;
}
/*
**********************************************************************************
*  minimax_vari_ungleich - sucht Variation mit ninimaler und maximaler 
*  Summe ungleicher gegen die TIPP_TAB
**********************************************************************************
*/
void  minimax_vari_ungleich(int den_nicht)
{
	int	it, itx, ivx, ungleiche, var;
	int	minsumme =999999999, maxsumme=0, minvar=-1, maxvar=-1, shift=12;
	
	for (var=0; var<VARIATIONEN; var++)
	{
		if (var == den_nicht)
			continue;
			
		ivx = var*SPIELE;
		ungleiche = 0;
		for (it=0; it < TIPPS; it++)
		{
			if (TIPP_TAB[it].var_akt >= 0)
			{
				itx = TIPP_TAB[it].var_akt *SPIELE;
				ungleiche += zaehle_ungleiche(&VARI[ivx], &VARI[itx]);
			}
		}
		
		ungleiche = (ungleiche <<10) + zufall(1 << shift);
		
		if (ungleiche < minsumme)		/* neuer min ? */
		{
			minsumme = ungleiche;
			minvar  = var;
		}

		if (ungleiche > maxsumme)		/* neuer max ? */
		{
			maxsumme = ungleiche;
			maxvar  = var;
		}
	}
	MINIMAL = minvar;
	MAXIMAL = maxvar;
}
/*
**********************************************************************************
*  minimax_vari_wert  - sucht Variation mit ninimalem oder maximalem Trefferwerten
**********************************************************************************
*/
void  minimax_vari_wert(void)
{
	int	i, ir=0, wert, rangwert, var;
	int	minwert=999999999, maxwert=0, minvar=-1, maxvar=-1, shift=10;
	
	/* Variation mit ninimalem oder maximalem Trefferwert suchen */
	
	for (var=0; var<VARIATIONEN; var++, ir+=5)
	{			
		if (den_nicht_rein(PRUEFEN, var))
			continue;
			
		wert = 0;		
		for(i=1; i<5; i++)
		{
			rangwert = RANG_TAB[ir+i] << RANG_BITS[i-1];
			wert += rangwert;
		}
		wert = (wert <<10) + zufall(1 << shift);

		if (wert < minwert)		/* minimal ? */
		{
			minwert = wert;
			minvar  = var;
		}

		if (wert > maxwert)		/* maximal ? */
		{
			maxwert = wert;
			maxvar  = var;
		}
	}
	MINIMAL = minvar;
	MAXIMAL = maxvar;
}
/*
*****************************************************************************
*  neue_methode  -  methoden-Wechsel
*****************************************************************************
*/
void   neue_methode(void)
{	
	static int	pos=0;
	
	METHODE_REIN = METHODEN[pos];
	METHODE_RAUS = METHODEN[pos];
	
	pos = (pos+1) % strlen(METHODEN);
}
/*
*****************************************************************************
*  neue_vorgaben  -  liest alle 5 Sekunden vorgaben.txt ein
*****************************************************************************
*/
void  neue_vorgaben(void)
{
	char	erstmalig  = FALSE;
	int   sekunden   = get_zeit(0);
	
	if (VORGABEN_ZEIT <0)
		erstmalig = TRUE;
	if ((sekunden < VORGABEN_ZEIT)  ||  (sekunden - VORGABEN_ZEIT >= 5))
	{
		VORGABEN_ZEIT = sekunden;
		lies_vorgaben(erstmalig);
	}
}
/*
*********************************************************************************
*  neuer_anlauf - FEST_GEFRESSEN - wieder auf letzten besten tipp zuruecksetzen
*********************************************************************************
*/
void  neuer_anlauf(void)
{
	char	i2=0, it=0, iv=0, ungleiche=99;
	char	perf_str[8];
	int     sekunden = get_zeit(0);
	float	perf;

	/* Meldung mit bisheriger Performance ausgeben */
	perf = (float)VERSUCHE/(sekunden - STARTZEIT);
	if (perf > 100)
	{
		sprintf(perf_str, "%-6.0f",perf);
	}
	else
	{
		if (perf < 1)
		{
			sprintf(perf_str, "%-6.4f",perf);
		}
		else
		{
			sprintf(perf_str, "%-6.2f",perf);
		}
	}
	if (PROGRAMM_FEHLER == FALSE)
		printf("\nneuer Anlauf nach %i Sekunden ohne Verbesserung - V/sek = %s\n", ANLAUF_ZEIT, perf_str); 
	
	ICH_BINS = FALSE;
	if (TP9 == 5069)
		ICH_BINS = TRUE;

	if (ZWI1_TREFFER > MEHR_TREFFER)
	{
		ZWI_ZAEHLER ++;
		if (ZWI_ZAEHLER < 10)
			bessere_tipps(ZURUECKHOLEN,1);
		else
		{
			ZWI_ZAEHLER = 0;
			bessere_tipps(ZURUECKHOLEN,2);
			bessere_tipps(SPEICHERN, 1);
			ZWI1_TREFFER = ZWI2_TREFFER;
			ZWI2_TREFFER = 0;
			
		}
	}
	berechne_raenge_voll();
	berechne_ungleiche_voll();
	zeige_auswertung(1);
	
	/* dann bei 1 Tipp Anzahl Tippzeichen lt. ANLAUF_WEITE austauschen */
	
	it = zufall(TIPPS);	
	den_nicht_rein(SPEICHERN, TIPP_TAB[it].var_akt);
		
	for (i2=TIPPS; i2>0; i2--)
	{
		iv = zufall(VARIATIONEN);	
		if ((den_nicht_rein(PRUEFEN, iv))  ||  (VAR_TIPPS[iv]))
			continue;

		ungleiche = zaehle_ungleiche(&VARI[iv], &VARI[it]);
		if (ungleiche <= ANLAUF_WEITE)
			break;
	}
	TIPP_TAB[it].var_akt = iv;

	berechne_raenge_voll();
	berechne_ungleiche_voll();
	FEST_GEFRESSEN = FALSE;
	zeige_auswertung(0);
}
/*
*****************************************************************************
*  optimiere - Reihen mit verschiedenen methoden austauschen
*****************************************************************************
*/
void  optimiere(void)
{
	int	it=0, iv=0;
	
	if (FEST_GEFRESSEN  ||  PROGRAMM_FEHLER)
	{
		METHODE_RAUS = ' ';
		METHODE_REIN = ' ';
		neuer_anlauf();
		neue_methode(); 
		PROGRAMM_FEHLER = FALSE;
	}
	else
	{
		/*
			RAUS = 1+ zufall(25);
			REIN = 1+ zufall(25);
		*/
			if (ZUFALL > SCHALTER)
			{
				METHODE_RAUS = '-';
				METHODE_REIN = '-';
			}
		
		if ((METHODE_RAUS > '5')  && (METHODE_RAUS <= '9'))
		{
			/* raus und rein in eimem Rutsch */
			raus_rein();
			if (PROGRAMM_FEHLER)
				printf("aufgerufen von optimiere %i\n", __LINE__-2);
		}
		else
		{
			/* oder raus und rein in zwei Schritten */
			it = raus();
			TIPP_TAB[it].var_alt = TIPP_TAB[it].var_akt;
			berechne_raenge(TIPP_TAB[it].var_alt, MINUS);
			
			if (PROGRAMM_FEHLER)
				printf("aufgerufen von optimiere %i\n", __LINE__-3);
			else
			{
				iv = rein(it);
				
				/* Tipp austauschen */	
				TIPP_TAB[it].var_akt = iv;
				berechne_raenge(iv, PLUS);
			}
		}	
		if (PROGRAMM_FEHLER == FALSE)		
			if (VERSUCHE<0)
			{
				/* zeige_daten( RANG_TAB, 160, 'i', 5); */
				printf("it=%i, iv=%i  \n", it, iv); 
				zeige_daten( TIPP_TAB, TIPPS*4+3, 'i', 4);
			}	
	}
}
/*
*****************************************************************************
*  optimum_erreicht - prueft ob bestmoegliches Ergebnis erreicht
*****************************************************************************
*/
char  optimum_erreicht(void)
{
	char     optimal=FALSE;
	
	/* Vorbedingung - 1.Rang fuer alle */
	
	if (TREFFER[0] == TIPPS)
	{
		/* Vollsystem ? */
		
		if (TIPPS == VARIATIONEN)
				optimal = TRUE;

		/* sonst */
		else
		{
			/* nur Rang 1 und 2 */
			if (TREFFER[2] + TREFFER[3] == 0)
				optimal = TRUE;
				
			/* oder Optimum Rang 2 erreicht und der Rest in Rang 3 */
			else
				if (BLOFIL[0].spiel_bits == 0)
					if (TREFFER[1] == OPTIMAL_RANG2  &&  (TREFFER[0]+TREFFER[1]+TREFFER[2]) == VARIATIONEN)
						optimal = TRUE;	
		}
	}
	return (optimal);
}
/*
*****************************************************************************
*  pendeln - sucht bessere Variation durch pendeln um den vorgegebenen Tipp
*****************************************************************************
*/
int  pendeln(int it, int var_ip, int redu_akt)
{
	int	i, redu_wert, redu_min = 999999999;
	int	var, var_min = BAD, var_it = TIPP_TAB[it].var_akt;
	int	von, bis;
	
	von = var_ip -(VARIATIONEN / TIPPS);
	bis = var_ip +(VARIATIONEN / TIPPS);

	for (i=von; i<bis; i++)
	{
		if (i != var_it)
		{
			var = i;
			if (var < 0)
				var += VARIATIONEN;
			if (var >= VARIATIONEN)
				var -= VARIATIONEN;
			if (den_nicht_rein(PRUEFEN, var))
				continue;
				
			TIPP_TAB[it].var_akt = var;
			berechne_ungleiche_voll();
			redu_wert = gib_redu_wert();
			
			/* bisher bester ? */
			if (redu_wert < redu_min)
			{
				redu_min = redu_wert;
				var_min  = var;
				
				/* auch besser als Ursprung ? */
				if (redu_wert < redu_akt)
					break;
			}
		}
		VERSUCHE ++;
	}
	TIPP_TAB[it].var_akt = var_it;
	TIPP_TAB[it].var_alt = var_min;
	TIPP_TAB[it].zwi     = redu_min;
	return (redu_min);
}
/*
*****************************************************************************
*  raus - Reihen aus der Tipp-Auswahl nehmen
*****************************************************************************
*/
int  raus(void)
{
	int	it=0, it1=0, it2=0, iv1=0, iv2=0;
	char  raus = METHODE_RAUS;
	
	switch (raus)
	{
		case '1' :		/* redundantester Tipp */
			it  = minimax_tipp_redun(PLUS);
			break;
			
		case '2' :		/* redundantester Tipp */
			it  = minimax_tipp_redun(PLUS);
			break;
			
		case '4' :		
			/* sucht Tipps mit < 3 Ungleichen */
			for (it1=0; it1<(TIPPS-1); it1++)
			{
				iv1  = TIPP_TAB[it1].var_akt *SPIELE;
				for (it2=it1+1; it2<TIPPS; it2++)
				{
					iv2 = TIPP_TAB[it2].var_akt *SPIELE;
					if (zaehle_ungleiche(&VARI[iv1], &VARI[iv2]) <6)
					{
						if (VERSUCHE & 1)
							it = it1+1;
						else
							it = it2+1;
						break;
					}
				}
				if (it)
					break;
			}
			if (it != 0)
				it --;
			else
				/* sonst - redundantester Tipp */
				it  = minimax_tipp_redun(PLUS);
			break;
			
		default :	   /* Zufall */
			it = zufall(TIPPS);	
			break;
	}
	return(it);
}
/*
********************************************************************************
*  raus_rein - fuer Methoden wo raus und rein zusammen ermittelt werden muessen
********************************************************************************
*/
int  raus_rein(void)
{
	int	it=0, iv=BAD, var_ip=BAD, pendel=TIPPS/10+1;
	int   redu_wert, redu_akt, redu_min=999999999;
	char  methode = METHODE_REIN;
		
	/* sucht bessere Variation ueber Tipp-Redundanzen */
	/* durch pendeln um den ausgewaehlten Tipp lt. Methode */				

	/* erst Tipps nach Redundanz sortieren */				
	it  = minimax_tipp_redun(PLUS);
	redu_akt = gib_redu_wert();
	
	/* dann Wert fuer pendeln lt. Methode */
	switch (methode)
	{
		case '6' :		/* kleinster Rangwert */
			minimax_vari_rang(); 
			var_ip = MINIMAL; 
			break;
			
		case '7':		/* kleinster Quotenwert */
			minimax_vari_wert(); 
			var_ip = MINIMAL; 
			break;
						
		default:		   /* Zufall */
			var_ip = zufall(VARIATIONEN);	
			break;
	}

	
	for (it=0; it<pendel; it++)
	{
		redu_wert = pendeln(it, var_ip, redu_akt);
		
		/* bisher bester ? */
		if (redu_wert < redu_min)
		{
			redu_min = redu_wert;
			
			/* auch besser als Ursprung ? */
			if (redu_wert < redu_akt)
				break;
		}
	}
	
	for (it=0; it<pendel; it++)
	{
		if (TIPP_TAB[it].zwi == redu_min)
		{
			iv = TIPP_TAB[it].var_alt;
			TIPP_TAB[it].var_alt = TIPP_TAB[it].var_akt;
			TIPP_TAB[it].var_akt = iv;
			berechne_raenge(TIPP_TAB[it].var_alt, MINUS);
			if (PROGRAMM_FEHLER)
			{
				printf("aufgerufen von raus_rein %i\n", __LINE__-2);
				break;
			}
			berechne_raenge(TIPP_TAB[it].var_akt, PLUS);
		}
		else
		{
			TIPP_TAB[it].var_alt = 0;				
		}
		TIPP_TAB[it].zwi = 0;
	}
			
	return(iv);
}
/*
*****************************************************************************
*  rein - neue Reihe in die Tipp-Auswahl
*****************************************************************************
*/
int  rein(int it)
{
	int	iv=0;
	char  rein = METHODE_REIN;	
		
	switch (rein)
	{
		case '3' :		/* Tipp mit den meisten ungleichen */
			minimax_vari_ungleich(it); 
			iv = MAXIMAL;
			break;
			
		case '2':		/* kleinster Trefferwert */
			minimax_vari_wert();
			iv = MINIMAL; 
			break;
						
		case '1':		/* sucht bessere Variation ueber RANG_TAB */
			minimax_vari_wert(); 
			iv = MINIMAL; 
			break;
												
		default:		/* Zufall */
			do 
			iv = zufall(VARIATIONEN);	
			while (den_nicht_rein(PRUEFEN, iv));
			break;
	}
			
	TIPP_TAB[it].var_akt = iv;		
	TIPP_TAB[it].zwi = 0;

	return(iv);
}
/*
*****************************************************************************
*  setze_filter  - Filter-Zeile aufloesen und einspeichern
*****************************************************************************
*/
int  setze_filter(int ib, int vorgabe_zeile)
{
	char	string[100];
	char  spiele=0, fehler=FALSE;
	int	i, ix, wert, max_bis=0, spiel_bits=0, or_bits=1;
	
	if (TEIL[1].STRING[0] != '-')
	{
		/* wenn Filter gueltig - Bits je Spiel dieses Filters setzen */
		spiele = 0;
		for (i=0; i<MAX_SPIELE; i++)
		{
			if (TEIL[2].STRING[i] == 'X')
			{
				spiel_bits |= or_bits;
				spiele ++;
			}
			or_bits <<= 1;
		}
	}
	if (spiel_bits)
	{
		BLOFIL[ib].vorgabe_zeile = vorgabe_zeile;
		BLOFIL[ib].spiel_bits    = spiel_bits;
		BLOFIL[ib].spiele		    = spiele;
		
		/* min/max-Werte speichern */	
		for (i=0; i<3; i++)
		{
			ix = i*2;
			strcpy(string, TEIL[i+3].STRING);
			BLOFIL[ib].grenze[ix]   = 0;
			BLOFIL[ib].grenze[ix+1] = 99;
			
			if (strlen(string))
			{
				wert = atoi(string);
				if (wert <100)
				{
					BLOFIL[ib].grenze[ix]	= wert /10;
					BLOFIL[ib].grenze[ix+1]	= wert %10;
					max_bis = wert %10;
				}
				else
				{
					BLOFIL[ib].grenze[ix]	= wert /100;
					BLOFIL[ib].grenze[ix+1]	= wert %100;
					max_bis = wert %100;
				}
			}
		}
		/* Plausi-Pruefung - Anzahl Spiele gegen min/max */
		for (ix=0; ix<6; ix+=2)
		{
			if (BLOFIL[ib].grenze[ix+1] == 99)
				continue;
				
			if (BLOFIL[ib].grenze[ix+1] > BLOFIL[ib].spiele)
			{
				fehler = TRUE;
				break;
			}
			spiele -= BLOFIL[ib].grenze[ix];
		}
		if (fehler || spiele <0)
		{
			
			printf("\n**********************************************************"
					 "\n  Filter in Zeile %i ist so nicht brauchbar "
			       "\n**********************************************************", BLOFIL[ib].vorgabe_zeile);
			und_tschuess (__LINE__, 0);
		}
	}
	/* interne Sprunglabel setzen */
	strcpy (BLOFIL[ib].name,   TEIL[1].STRING); 
	strcpy (BLOFIL[ib].ok,     TEIL[6].STRING); 
	strcpy (BLOFIL[ib].falsch, TEIL[7].STRING); 
	
	return (spiel_bits);
}
/*
*****************************************************************************
*  speichere_system_zeile 
*****************************************************************************
*/
void   speichere_system_zeile(char modus, char* zeile)
{
	int    i, laenge, tipp_zeichen;
	char   gespeichert = FALSE;
	
	laenge = strlen(zeile);

	if (SENKRECHT_EIN)
	{
		if (modus == SPEICHERN_SYSTEM)
			SPIEL  = 0;
		else
			SPIEL  = SYSTEM_SPIELE;
	}
	else
	{
		if (modus == SPEICHERN_SYSTEM)
			TIPP   = SYSTEM_TIPPS;
		else
			TIPP   = 0;
	}

	for (i=0; i<laenge; i++)
	{
		if (zeile[i] == 'X')
			zeile[i] ='0';
		if ((zeile[i] >='0') && (zeile[i] <='2'))
		{
			gespeichert = TRUE;
			tipp_zeichen = zeile[i]-'0';
			if (tipp_zeichen <2)
				tipp_zeichen = 1 -tipp_zeichen;		/* 0 und 1 austauschen */
			CTAB[TIPP*SPIELE+SPIEL] = tipp_zeichen;
			if (gespeichert)
			{
				if (SENKRECHT_EIN)
					SPIEL  ++;
				else
					TIPP   ++;
			}
			if (SPIEL > SPIELE)
			   und_tschuess(__LINE__, 2);
		}
	}
	
	/* Zeile komplett bearbeitet */
	
	if (gespeichert)
	{
		if (SENKRECHT_EIN)
		{
			TIPP   ++;
		}
		else
		{
			if (SPIEL >= SPIELE)
			   und_tschuess(__LINE__, 2);
			   
			SPIEL  ++;
		}
		
		if (modus == SPEICHERN_BLOCK)
		{
			BLOCK_TIPPS  = TIPP;
			BLOCK_SPIELE = SPIEL -SYSTEM_SPIELE;
		}
	}
}
/*  
*****************************************************************************   
*  sor  -  Funktion fuer Sortierung mit qsort
*****************************************************************************   
*/  
int      sor(const void* a, const void* b)
{   
	int	ix = SORTIERUNG %100;
	int   folge = 0, richtung = 1;
	
	const int** ia = (const int **) a; 
	const int** ib = (const int **) b; 
	
		
	if (ia[ix] != ib[ix])
	{
		if (SORTIERUNG >99)
			richtung = -1;						// falls absteigend sortiert wird
			
		if (ia[ix] > ib[ix])
			folge = richtung ;
		else
			folge = richtung * -1;
	}
	return folge;
}
/*
*********************************************************************************
*  string_teilen  -  teilt String lt. Trennzeichen (bei Blank - mehrere wie eins)
*********************************************************************************
*/
int   string_teilen(char *string, char trenner)
{
  char  				string_zwi[2100] ;
  unsigned int   	ec ;                 /* Column-No. Eingabe-String */
  unsigned int   	tc ;                 /* Column-No. Teil-String-Anfang */
  unsigned int		i;

  string_to_upper(string_zwi,string);
  for(i=0; i<MAX_TEILSTRINGS; i++)
    strcpy(TEIL[i].STRING, "");
  for(i=0, ec=0, tc=0 ; ec <= strlen(string); ec++ )
  {
    if ( string_zwi[ec] == trenner  ||  ec >= strlen(string))
    {
      if (ec != 0  ||  trenner != ' ')
      {
        string_zwi[ec]=0;
        strcpy(TEIL[i].STRING, &string_zwi[tc]);
        i++;
      }
      while ( string_zwi[ec+1] == trenner  &&  ec < strlen(string))
      {
        ec++;
        if (trenner != ' ')
          i++;
      }
      tc = ec+1;
    }
    else
      if ( (i+1) >= MAX_TEILSTRINGS)
      {
        strcpy(TEIL[i].STRING, &string_zwi[tc]);
        break;
      }
  }
  return (i-1);
}
/*
*****************************************************************************
*  string_to_upper  -  String auf Grossbuchstaben umsetzen
*****************************************************************************
*/
void   string_to_upper(char* ziel, char* quelle)
{
  unsigned int   i ;

  for (i=0; i<strlen(quelle); i++)
    ziel[i] = toupper(quelle[i]);
  ziel[i] = '\0';
}
/*
*****************************************************************************
*  und_tschuess  -  Ausgabe einer Fehlermeldung 
*****************************************************************************
*/
void  und_tschuess(int prog_zeile, int fehler)
{
	
	switch (fehler)
	{
		case 1 :
			printf("\n******************************************************"
			       "\nKeine Ausgabe waagerecht mit mehr als 20000 Tippreihen"
			       "\n******************************************************");
			break;
			
		case 2 :	
			printf("\n*****************************************************************************"
					 "\nMehr Spiele im System als Wege vorgegeben - System oder Orientierung nicht OK"
					 "\n*****************************************************************************");
			break;
			
		case 3 :
			printf("\n*****************************"
			       "\nMehr als 16 Mio Variationen"
			       "\n******************************");
			break;
			
		case 4 :
			printf("\n**************************************************************"
			       "\nZiel-Rang bitte nur 2 bis 4"
			       "\n**************************************************************");
			break;
			
			
		case 5 :
			printf("\n**************************************************************"
			       "\nSpiel-Zuordnung passt nicht"
			       "\n**************************************************************");
			break;
			
		default :	   /* andere */
			break;
	}
	printf("\n*****  siehe bei Programm-Zeile %-4i  ***** \n", prog_zeile);
	printf("*****       ... UND TSCHUESS !!       ***** \n", prog_zeile);
	exit (1); 
}
/*  
******************************************************************************   
*  vari_speichern  -  moegliche Variationen aus WEGE und Filtern einspeichern
******************************************************************************   
*/  
int   vari_speichern(void)
{   
  char   	  spiel, reihe[MAX_SPIELE+1];
  int         i, var_x, reihen=0, vollsys, status;
  
  /* RANG_TAB wird hier als Hilfsspeicher genutzt */  
  memset (RANG_TAB,   0, VARIATIONEN*5*sizeof(int));
  
	/* ----------------------------------------------------- 
	Anzahl moeglicher Variationen lt. Vorgaben berechnen,
	und in die VARI-Tabelle einspeichern
	----------------------------------------------------- */  
	spiel  = 0;
	var_x  = 0;
	for (i=0; i<SPIELE; i++)
		reihe[i] = 0;
	reihe[i] = BAD;
	
	for (vollsys=0; vollsys < VARIATIONEN; vollsys ++)
	{
	/* generiere naechste Reihe */
	
		for (spiel=SPIELE-1; spiel >= 0; spiel--)
		{
			if (reihe[spiel] < WEG[spiel])
				break;
			reihe[spiel]   = 0;
			if (spiel >0)
				reihe[spiel-1] ++ ;
		}
	
		/* Filter-Pruefungen fuer diese Reihe */		
		status = OK;
		if (FILTER)
			status = filter_pruefung(reihe);
	
		if (status == OK)
		{				
			/* Maximal-Pruefung */
			
			if (reihen >MAX_VARIATIONEN)
				und_tschuess(__LINE__, 3);
				
			/* Variation einspeichern */		
			memcpy (&VARI[var_x], reihe, SPIELE+1);
			
			/* vari-Nr., Zufallswert und Index fuer spaetere Umsortierungen nach RANG_TAB */
			RANG_TAB[reihen*3]   = reihen;
			RANG_TAB[reihen*3+1] = zufall(100000000);	
			RANG_TAB[reihen*3+2] = var_x;	
			
			reihen ++;
			var_x  += SPIELE;
		}
		reihe[SPIELE-1] ++;
	}
	status = reihen ; 
	return (status); 
}   
/*  
*****************************************************************************   
*  was_gebracht  -   prueft, ob die vorige Aktion was gebracht hat
*****************************************************************************   
*/  
int   was_gebracht(void)
{   
	int		treffer_wert;
	int		ergebnis = FALSE;
	
	gib_treffer_summen();
	treffer_wert = gib_treffer_wert();
	ergebnis = treffer_wert - MEHR_TREFFER;
	
	/* bei neuem Anlauf positives Ergebnis setzen */
	VERSUCHE ++;
	if (FEST_GEFRESSEN)
	{
		ergebnis = 1;
	}
			
	if (ergebnis >0)
	{
		MEHR_TREFFER = treffer_wert;
		
		if (MEHR_TREFFER > ZWI2_TREFFER  &&  MEHR_TREFFER < ZWI1_TREFFER)
		{
			ZWI2_TREFFER = MEHR_TREFFER;
			bessere_tipps(SPEICHERN, 2);
		}

		if (MEHR_TREFFER > ZWI1_TREFFER)
		{
			ZWI1_TREFFER = MEHR_TREFFER;
			ZWI_ZAEHLER  = 0;
			bessere_tipps(SPEICHERN, 1);
			ZWI2_TREFFER = 0;
		}
					
		if (MEHR_TREFFER > MAX_TREFFER)
		{
			zeige_system(SCHREIBEN);
			MAX_TREFFER = MEHR_TREFFER;
		}
		zeige_auswertung(0);
	}
	return (ergebnis);
}	
/*
*****************************************************************************
*  wechsele_zurueck  -  Wechsel rueckgaengig machen
*****************************************************************************
*/
void     wechsele_zurueck(char version)
{
     
   /* Rueck-Wechsel und Rueck-Rechnung wenn nichts gebracht 
    * alle Tabellen aus Sicherung zuruecksetzen */
	
	if (version == 'R')
		/* mit RANG_TAB */
		memcpy(RANG_TAB, SAV_RANG_TAB, sizeof(int)*5*VARIATIONEN); 
		
	/* sonst nur TIPP_Tabellen */
	memcpy(TIPP_TAB, SAV_TIPP_TAB, sizeof(TIPP_TAB[0])*TIPPS); 
	memcpy(VAR_TIPPS, SAV_VAR_TIPPS, VARIATIONEN); 
	memcpy(TIPP_REDU, SAV_TIPP_REDU, sizeof(TIPP_REDU)); 
}
/*
*****************************************************************************
*  zaehle_ungleiche - Tippvergleich mit Differenzen-Zaehlung
*****************************************************************************
*/
char  zaehle_ungleiche(char* tipp1, char* tipp2)
{
	char     spiel, ungleiche=0;
	
	for (spiel=0; spiel < SPIELE; spiel++)
	{
		if (tipp1[spiel] != tipp2[spiel])
			ungleiche ++;
	}
	return (ungleiche);
}
/*
*****************************************************************************
*  zeige_auswertung  -  Ausgabe der Auswertung
*****************************************************************************
*/
void   zeige_auswertung(char kopf)
{
	float   tproz[4];
	char    i;
	int     dauer, rest, wert, quoten_wert=0, rangbit_wert=0;
	int     sekunden = get_zeit(0);

	dauer = (sekunden-STARTZEIT);
		
	for (i=0; i<4; i++)
	{
		tproz[i]       = (float)TREFFER [i] *100 / VARIATIONEN;
		
		if (i>0)
		{
			wert = TREFFER[i] << QUOTEN_BITS[i];	 
			quoten_wert += wert;	 
			wert = TREFFER[i] << RANG_BITS[i];	 
			rangbit_wert += wert;	 
		}
	}
  
	if (VERSUCHE == 0)
	{
		printf("\n%2i:%02i:%02i  %s optimiert %i Spiele mit %i von %i moeglichen Reihen \n", 
				  (sekunden %86400)/3600, sekunden /60 %60, sekunden %60, VERSION,
					SPIELE, TIPPS, VARIATIONEN);
		printf("          - Optimum Rang 2 = %i  (nur wenn ungefiltert)\n", OPTIMAL_RANG2); 
	}
	if (kopf)
	{
		LOOP_ZEIT     = clock();
		LOOP_VERSUCHE = 0;
			
		printf("\n Uhrzeit |         Bester Rang        |  Proz. incl. hoeherer Raenge  | T-Wert    Rest  Versuche    Sek |");
		if (ICH_BINS)
			printf(" MS rausrein");
		printf("\n");
		
		printf(  "---------|----------------------------|-------------------------------|---------------------------------|");
		if (ICH_BINS)
			printf("------------");
		printf("\n");		
	}
	rest = VARIATIONEN -TREFFER[0] -TREFFER[1] -TREFFER[2] -TREFFER[3];

	printf("%2i:%02i:%02i | %4i %6i %6i %6i  | %5.2f  %6.2f %7.2f %7.2f |%7i%8i%10i%7i |",
		(sekunden %86400)/3600, sekunden /60 %60, sekunden %60, TREFFER[0], TREFFER[1], TREFFER[2], TREFFER[3],
		tproz[0], tproz[1] +tproz[0], tproz[2] +tproz[1] +tproz[0], tproz[3] +tproz[2] +tproz[1] +tproz[0], rangbit_wert, 
		rest, VERSUCHE, dauer);

	if (ICH_BINS)
		printf(" %c%i%4i%4i", METHODE_REIN, SCHALTER, RAUS, REIN);
	printf("\n");	
	
	MAX_GEZEIGT = MEHR_TREFFER;
	/*
	zeige_rangtab(__LINE__, 0);
	zeige_tipptab(__LINE__, 0);
	*/
}
/*
*****************************************************************************
*  zeige_daten  -  Ausdruck von Daten-Saetzen
*****************************************************************************
*/
void  zeige_daten( void *satz, int laenge, char format, int werte_je_zeile) 
{
	int      i;
	char     lin_zeile[200]="      " ;
	char     *char_ptr  =satz;
	int      *int_ptr   =satz;
	float    *float_ptr =satz;
	
	printf("\nProgramm-Zeile %4i \n", __LINE__);
	for ( i=0; i<laenge; i++)
	{
		if ((i % werte_je_zeile) == 0)
		{
			if (i  &&  format == 'a')
			{
				printf("\n%s",lin_zeile);
				printf("\n%4i  ",i*4);
				strcpy(lin_zeile,"      ");
			}
			else
				printf("\n%04i  ",i);
		}
		switch (format)
		{
			case  'f'   :
				printf("%.2f  ", float_ptr[i]);
				break ;
				
			case  'c'   :
				printf("%c ",    char_ptr[i]);
				break ;
				
			case  'b'   :
				printf("%3i ",    char_ptr[i]);
				break ;
				
			case  'o'   :
				printf("%012o  ",int_ptr[i]);
				break ;
				
			default  :
				printf("%10i ",int_ptr[i]);
		}
	}
	if (format == 'a')
		printf("\n%s",lin_zeile);
	printf ("\n");
}
/*
*****************************************************************************
*  zeige_filter  -  Ausdruck der Filtertabelle
*****************************************************************************
Aufruf:     zeige_filter(__LINE__);
*/
void  zeige_filter(int prog_zeile)
{
	int	i;
	
	for (i=0; BLOFIL[i].spiel_bits; i++)
	{
		if (i == 0)	
			printf("\nBLOFIL - Programm-Zeile %4i \n", prog_zeile);
		printf("V-Zeile=%-4i  Name=%-4s  Bits=%06o   Spiele=%-2i    G=%i-%-2i    A=%i-%-2i    U=%i-%-2i    OK=%-6s  falsch=%-6s\n", 
		BLOFIL[i].vorgabe_zeile, BLOFIL[i].name, BLOFIL[i].spiel_bits, BLOFIL[i].spiele,
		BLOFIL[i].grenze[0], BLOFIL[i].grenze[1], BLOFIL[i].grenze[2], 
		BLOFIL[i].grenze[3], BLOFIL[i].grenze[4], BLOFIL[i].grenze[5],	BLOFIL[i].ok, BLOFIL[i].falsch);
	}
}
/*
*****************************************************************************
*  zeige_rangtab  -  Ausdruck der RANG_TAB
*****************************************************************************
Aufruf:     zeige_rangtab(__LINE__, 0);
*  &VARI[iv*SPIELE], SPIELE, 'b', SPIELE);
*/
void  zeige_rangtab(int prog_zeile, int elemente)
{
	char	reihe[12]="           ";
	char	leer[12] ="           ";
	char	leer1[12]="           ";
	char	leer2[12]="           ";
	int	i, i2;
	
	if (elemente == 0)
		elemente = VARIATIONEN;					/* wenn 0 - alle */
		
	for (i=0; i<elemente; i++)
	{
		if (i == 0)
		{
			leer1[11-SPIELE] = 0;
			printf("\nRANG_TAG - Programm-Zeile %4i \n\n", prog_zeile);
		}
		for (i2=0; i2<SPIELE; i2++)
			reihe[i2] = VARI[i*SPIELE+i2] +'0';
		reihe[i2] = 0;
		
		strcpy(leer2, leer);
		leer2[RANG_TAB[5*i]*2] = 0;
		
		printf("Element%3i  %s%s Raenge 1-4   %4i   %4i   %4i   %4i  bester  %s%i\n", 
		i, reihe, leer1, RANG_TAB[5*i+1], RANG_TAB[5*i+2], RANG_TAB[5*i+3], 
		RANG_TAB[5*i+4], leer2, RANG_TAB[5*i]);
	}
}
/*
*****************************************************************************
*  zeige_system  -  Ausgabe des Systems
*****************************************************************************
*/
void  zeige_system(int aktion)
{
	FILE*    ausgabe_file = NULL ;
	char     name[]="neusys.txt";
	int      spiel, tipp, iv, sysspiel;
	char     tipp_zeichen;
	char     zeile[20010];
	
	if (aktion == SCHREIBEN)
	{
		ausgabe_file = fopen(name,"w");
	}
	else
	printf("\n");
	
	/* Systemausgabe nach VARI-Reihenfolge */
	
		SORTIERUNG = 0;
		qsort (TIPP_TAB, TIPPS, sizeof(TIPP_TAB[0]), sor);
	
	if (SENKRECHT_AUS == FALSE)
	{
		/* Ausgabe waagerecht */
		if (TIPPS >20000)
			und_tschuess(__LINE__,1);
			
		for ( spiel=0; spiel < SPIELE; spiel++)
		{
			sprintf(zeile,"%c\0",VORSPANN);
			/* printf(zeile); */
			
			sysspiel = SPIEL_ZUORDNUNG[spiel];
			for ( tipp=0; tipp < TIPPS; tipp++)
			{
				if (SYS_TEILUNG  &&  tipp  && (tipp % SYS_TEILUNG ==0))
					sprintf(zeile,"%s%c\0",zeile, SYS_TRENNER);
					
				if (VOLLSYSTEM)
					iv = tipp;
				else
					iv = TIPP_TAB[tipp].var_akt;
					
				tipp_zeichen = AUSGABE_ZEICHEN[(VARI[iv*SPIELE+sysspiel]) +(4*spiel)];
				sprintf(zeile, "%s%c", zeile, tipp_zeichen);
			}
			strcat(zeile,"\n");
					
			if (SYSTEM_ZEIGEN)
				printf(zeile);
			
			if (aktion == SCHREIBEN)
				fprintf(ausgabe_file, zeile);
		}
	}
	else
	{
		/* Ausgabe senkrecht */
		
		for ( tipp=0; tipp < TIPPS; tipp++)
		{
			sprintf(zeile,"%c\0",VORSPANN);
			/* printf(zeile); */
			for ( spiel=0; spiel < SPIELE; spiel++)
			{
				sysspiel = SPIEL_ZUORDNUNG[spiel];
				if (SYS_TEILUNG  &&  spiel  && (spiel % SYS_TEILUNG ==0))
					sprintf(zeile,"%s%c\0",zeile, SYS_TRENNER);
					
				if (VOLLSYSTEM)
					iv = tipp;
				else
					iv = TIPP_TAB[tipp].var_akt;
					
				tipp_zeichen = AUSGABE_ZEICHEN[(VARI[iv*SPIELE+sysspiel]) +(4*spiel)];
				sprintf(zeile, "%s%c", zeile, tipp_zeichen);
			}
			strcat(zeile,"\n");
					
			if (SYSTEM_ZEIGEN)
				printf(zeile);
			
			if (aktion == SCHREIBEN)
				fprintf(ausgabe_file, zeile);
		}
	}
	if (aktion == SCHREIBEN)
		fclose(ausgabe_file);
}
/*
*****************************************************************************
*  zeige_tipptab  -  Ausdruck der TIPP_TAB
*****************************************************************************
Aufruf:     zeige_tipptab(__LINE__, 0);
*  &VARI[iv*SPIELE], SPIELE, 'b', SPIELE);
*/
void  zeige_tipptab(int prog_zeile, int elemente)
{
	char	reihe[12]="           ";
	char	leer[12] ="           ";
	int	i, i2;
	
	if (elemente == 0)
		elemente = TIPPS;					/* wenn 0 - alle */
		
	for (i=0; i<elemente; i++)
	{
		if (i == 0)
		{
			leer[11-SPIELE] = 0;
			printf("\nTIPP_TAB - Programm-Zeile %4i \n\n", prog_zeile);
		}
		for (i2=0; i2<SPIELE; i2++)
			reihe[i2] = VARI[TIPP_TAB[i].var_akt*SPIELE+i2] +'0';
		reihe[i2] = 0;
		
		printf("Element%3i  %s%s var_akt=%4i  var_alt=%4i  ungleich=%4i  zwi=%4i\n", 
		i, reihe, leer, TIPP_TAB[i].var_akt, TIPP_TAB[i].var_alt, 
		TIPP_TAB[i].ungleich, TIPP_TAB[i].zwi);
	}
}
/*
*****************************************************************************
*  zeitraum_abgelaufen  -  gibt abgelaufene Sekunden zurueck wenn abgelaufen 
*****************************************************************************
*/
int  zeitraum_abgelaufen(int zeitraum)
{
	int	abgelaufen = FALSE;
	int   sekunden   = get_zeit(0);
	
	if ((sekunden < ZEITSTEMPEL)  ||  (sekunden - ZEITSTEMPEL >= zeitraum))
	{
		abgelaufen = sekunden -ZEITSTEMPEL;
		ZEITSTEMPEL = sekunden;
		return (abgelaufen);
	}
	else
		return (FALSE);
}
/*
*****************************************************************************
*  zeitraum_starten  -  setzt neuen Zeitstempel
*****************************************************************************
*/
void  zeitraum_starten(void)
{
	int    sekunden = get_zeit(0);

	ZEITSTEMPEL = sekunden;
}
/*
*****************************************************************************
*  zufall - Zufallszahl ermitteln  - nicht rand()
*****************************************************************************
*/
int	zufall(int modulo)
{	
	static long long	x = 230230230;

	long long			a = 23023023; 
	int					c = STARTZEIT;
	
	x = (x *a +c) % 07777777773;
		
	return (x % modulo);
}
