#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>


#define TAB                   011
#define TRUE                    1
#define FALSE                   0
#define OK                      0
#define BAD                    -1
#define INAKTIV                -1
#define PLUS                    1
#define MINUS                  -1
#define LETZTER                 9

#define MAX_TEILSTRINGS       150

#define MAX_FILTER            210
#define MAX_METHODEN           20
#define MAX_SPIELE             15 
#define MAX_TIPPS           20000
#define MAX_VARIATIONEN  16000000

/* Aktionen und Eigenschaften */

#define ANLEGEN                 1
#define BERECHNEN               2
#define BEWERTEN                3
#define SPEICHERN               4
#define SPEICHERN_SYSTEM        40
#define SPEICHERN_BLOCK         41
#define SCHREIBEN               5
#define PRUEFEN                 6
#define ZURUECKHOLEN            7
#define SPERREN                 8

#define SEQUENTIELL             0
#define KURZ                    2
#define LANG                    3
#define UNBEGRENZT             -1
/*
*****************************************************************************
* typedefs
*****************************************************************************
*/

/*
*****************************************************************************
* globale Variable
*****************************************************************************
*/

 /* Tabelle fuer Teil-Strings */ 
struct teil
{
  char  STRING[200];                     
}TEIL[MAX_TEILSTRINGS];

int       TIPPS_EINS[MAX_TIPPS];            /* Tabelle zur Speicherung der besten Tipps */ ;
int       TIPPS_ZWEI[MAX_TIPPS];            /* Tabelle zur Speicherung der zweitbesten Tipps */ ;

char      CTAB[MAX_SPIELE*MAX_TIPPS];       /* Tabelle zur kurzfristigen Speicherung von CHAR-Werten */
char      VARI[MAX_SPIELE*MAX_VARIATIONEN]; /* Tabelle fuer moegliche Variationen */
char      VAR_TIPPS[MAX_VARIATIONEN];       /* Tabelle der ausgewaehlten Variationen */

int       RANG_TAB[5*MAX_VARIATIONEN];      /* Tabelle fuer Rang-Auswertung  */

char      WEG[MAX_SPIELE+1];                /* Tabelle zur 2- und 3-Weg-Berechnung */

char      AUSGABE_ZEICHEN[100]	="102 102 102 102 102 102 102 102 102 102 102 102 102 102 102 102 102 ";   

char      SPIEL_ZUORDNUNG[] 		={ 1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
												1,  3,  6, 10, 15, 21, 28, 36, 45, 55, 66, 78, 91,105,120 }; 
   



 /* ---------------------------------------------
    Speicher fuer Systemdimensionen
    --------------------------------------------- */
    
char      SPIEL=0, SPIELE=0, SYSTEM_SPIELE=0, BLOCK_SPIELE=0;

int       TIPP=0, TIPPS=0, SYSTEM_TIPPS=0, BLOCK_TIPPS=0, SOLL_TIPPS=0;

 /* ---------------------------------------------
    Speicher zur Trefferbild-Auswahl der Filter
    --------------------------------------------- */
struct
{
   int   vorgabe_zeile;
	int	spiel_bits ;
   char  spiele;
	char	grenze[6] ;
	char	name[8];
	char	ok[8];
	char	falsch[8];
}BLOFIL[MAX_FILTER+2];

char	METHODEN[MAX_METHODEN+1] ="0000"; 

struct 
{
	int   var_akt;
	int   var_alt;
	int   ungleich;
	int   zwi;
}TIPP_TAB[MAX_TIPPS];                  /* Tabelle zur Speicherung der Tipp-Daten */ ;

int		TIPP_REDU[8];

/* Backups */

char  SAV_RANG_TAB[sizeof(RANG_TAB)]; 
char  SAV_TIPP_TAB[sizeof(TIPP_TAB)];
char  SAV_TIPP_REDU[sizeof(TIPP_REDU)];
char  SAV_VAR_TIPPS[sizeof(VAR_TIPPS)];
/* ------------------------------------------- */

char		ABBRUCH = FALSE;             /* gezielter Programmabbruch */
char		ALLE_VARIATIONEN = TRUE;
char		FILTER = TRUE;
char		ICH_BINS = FALSE;
char		METHODE_RAUS = '0';
char		METHODE_REIN = '0';
char		VORSPANN = 0;
char		QUOTEN_BITS[4] = {13,8,4,1};  /* Shift-Faktor je Rang f. MEHR_TREFFER */
char		RANG_BITS[4]   = {13,8,4,1};  /* Shift-Faktor je Rang f. MEHR_TREFFER */
char		SCHALTER = 0;
char		SENKRECHT_EIN = FALSE;        /* Eingabe-System senkrecht orientiert  */
char		SENKRECHT_AUS = FALSE;        /* Ausgabe-System senkrecht orientiert  */
char		SYS_TRENNER = 0;              /* Trennzeichen im Ausgabe-System */
char		SYS_TEILUNG = 0;              /* Abstand der Trennzeichen */
char		VOLLSYSTEM = FALSE;
char		ZIEL_RANG = 2;

int		FEST_GEFRESSEN=FALSE;
int		ANLAUF_ZEIT = 30;
int		ANLAUF_WEITE = 2;
int		STARTSYSTEM = 0;
int		VARIATIONEN=1;
int		TREFFER[4];
int		SYSTEM_ZEIGEN=FALSE;
int		STARTZEIT;
int		SORTIERUNG=0;
int		ZEITSTEMPEL=-1;
int		VORGABEN_ZEIT=-1;
int		LOOP_ZEIT;                  /* fuer Zeitdifferenz-Berechnungen */
int		LOOP_VERSUCHE;
int		MEHR_TREFFER=0;             
int		ZWI1_TREFFER=0;
int		ZWI2_TREFFER=0;
int		MAX_TREFFER=0;
int		MAX_GEZEIGT=0;
int		ZWI_ZAEHLER=0;
int		WIE_OFT=1999999999;         /* Anzahl Optimierungs-Versuche bis Stop */
int		VERSUCHE=0;                 /* gelaufene Optimierungs-Versuche */
int		OPTIMAL_RANG2 = 0;          /* Maximale Rang2-Moeglichkeiten */
int		NICHT_REIN[] = {-1, -1, -1};
int		ZUFALL=8;
int		RAUS=16;
int		REIN=16;
int   	MINIMAL;
int   	MAXIMAL;
int   	PROGRAMM_FEHLER = FALSE;

int		TP1=0;							/* 9 Test-Parameter */
int		TP2=0;
int		TP3=0;
int		TP4=0;
int		TP5=0;
int		TP6=0;
int		TP7=0;
int		TP8=0;  /* Startsystem 1= alle Tipps per Zufall */
int		TP9=0;  /* 5069 bin ich */

char		VERSION[55] = "";
/*
*****************************************************************************
* Funktionen deklarieren
*****************************************************************************
*/
void     aktualisiere_system(char);          /* aktualisiert das System bei Block-Wechsel */
void     baue_start(int);                    /* Start-System voroptimiert aus moeglichen Variationen */ 
int      baue_start_test(int);               /* Start-System mit Testversion aufbauen */ 
void     berechne_raenge(int,int);           /* Rangtreffer eines Tipps gegen alle Variationen verrechnen */
void     berechne_raenge_voll();             /* komplette Rangtreffer-Ermittlung und Summierung  */
void     berechne_ungleiche(int,int);        /* rechnet Redundanzen fuer einen Tipp rein oder raus */
void     berechne_ungleiche_voll();          /* berechnet alle Tipp-Redundanzen */
void     bessere_tipps(char, char);          /* bessere TIPP_TAB zwischenspeichern oder zurueckholen */
int      den_nicht_rein(int, int );
void     deutscher_monat(char*);             /* deutscher Monat aus __DATE__ */
char     filter_pruefung(char*);             /* Reihe gegen Filter-Vorgaben pruefen */
int      get_zeit(time_t*);                  /* Tag und Uhrzeit ermitteln */
int      gib_redu_wert(void);                /* Werte aus TIPP_REDU */
void     gib_treffer_summen(void);           /* summiert Treffer ueber die die RANG_TAB */
int      gib_treffer_wert(void);             /* Werte aus RANG_TAB */
char     gleicher_tipp(char*,char*);         /* Zwei Tipps vergleichen */
char     lies_system(char);                  /* System aus Datei  */
char     lies_vorgaben(char);                /* Vorgaben  aus Datei */
int      min_tipp_ungleich(int,int);         /* minimale Abweichung ein Tipp gegen eine Variation */
int      minimax_tipp_redun(int);			   /* sucht Tipp mit groesster und kleinster Redundanz */
void     minimax_vari_rang(void);			   /* sucht Variation mit bestem und schlechtestem Rang */
void     minimax_vari_ungleich(int);		   /* sucht Variation mit ninimaler und maximaler Summe ungleicher */
void     minimax_vari_wert(void);			   /* sucht Variation mit ninimalem und maximalem Trefferwert */
void     neue_methode(void);                 /* Methoden-Wechsel */
void     neue_vorgaben(void);                /* liest alle 5 Sekunden vorgaben.txt ein */
void     neuer_anlauf(void);                 /* festgefressen - wieder auf letzten besten tipp zuruecksetzen */
void     optimiere();                        /* Reihen mit verschiedenen Methoden austauschen */
char     optimum_erreicht(void);             /* prueft ob bestmoegliches Ergebnis erreicht */
int      pendeln(int,int,int);               /* sucht bessere Variation durch pendeln um den vorgegebenen Tipp */
int      raus(void);                         /* Reihen aus der Tipp-Auswahl nehmen */
int      raus_rein(void);                    /* fuer Methoden wo raus und rein zusammen ermittelt werden muessen */
int      rein(int);                          /* neue Reihen in die Tipp-Auswahl */
int      setze_filter(int,int);              /* Filter-Zeile aufloesen und einspeichern */
int      sor(const void*,const void*);       /* Funktion fuer Sortierung mit qsort */
void     speichere_system_zeile(char,char*); /* aus Vorgabe-Datei */
int      string_teilen(char*,char);          /* teilt String lt. Trennzeichen */
void     string_to_upper(char*,char*);       /* String auf Grossbuchstaben umsetzen */
void		und_tschuess(int,int);              /* Ausgabe einer Fehlermeldung */
int      vari_speichern(void);               /* moegliche Variationen aus WEGE und Filtern einspeichern */
int      was_gebracht();     		             /* prueft, ob die vorige Aktion was gebracht hat */
void     wechsele_zurueck(char);             /* Wechsel rueckgaengig machen */
char     zaehle_ungleiche(char*,char*);      /* Tippvergleich mit Differenzen-Zaehlung */
void     zeige_auswertung(char);             /* Ausgabe der Auswertung */
void     zeige_daten(void*,int,char,int);    /* Ausgabe am Bildschirm */
void		 zeige_filter(int);                  /* Ausdruck der Filtertabelle */
void		 zeige_rangtab(int,int);             /* Ausdruck der RANG_TAB */
void     zeige_system(int);                  /* Ausgabe des Systems */
void		 zeige_tipptab(int,int);             /* Ausdruck der TIPP_TAB */
int      zeitraum_abgelaufen(int);           /* gibt abgelaufene Sekunden zurueck wenn abgelaufen */
void     zeitraum_starten(void);             /* setzt neuen Zeitstempel */
int      zufall(int);  								// Zufallszahl ermitteln  - nicht rand()
